#version 450 core

layout (location = 0) in vec3 position;

layout(std140, binding = 0) uniform VP{
    mat4 view;
    mat4 projection;
};

uniform vec3 center;
uniform float radius;

out vec3 pixelPosition;

void main(){
    vec3 cameraRightWorldSpace = (inverse(view) * vec4(1,0,0,0)).xyz;
    vec3 cameraUpWorldSpace = (inverse(view) * vec4(0,1,0,0)).xyz;

    vec3 cameraPosWorldSpace = (inverse(view) * vec4(0,0,0,1)).xyz;

    vec3 forward = normalize(cameraPosWorldSpace - center);
    vec3 right = normalize(cross(forward, cameraUpWorldSpace));
    vec3 up = normalize(cross(forward, right));

    vec3 vertexPosition_worldspace =
        center
        + (right * position.x * radius)
        + (up * position.y * radius);

    gl_Position = projection*view* vec4(vertexPosition_worldspace,1.0);
    pixelPosition = (view* vec4(vertexPosition_worldspace,1.0)).xyz;

}

