#version 450 core

layout(triangles) in;
layout (line_strip, max_vertices = 6) out;

layout(std140, binding = 0) uniform VP
{
    mat4 view;
    mat4 projection;
    vec4 waterClipPlane;
};

layout(std140, binding=1) uniform Lights{
	int numLights;
	vec4 position[11];
	vec3 ambient[11];
	vec3 diffuse[11];
	vec3 specular[11];
	vec3 attenuation[11];
	float lightFar[11];
};

void main(){
	
	for(int vertex = 0; vertex < 3; vertex++)
	{
		for(int light = 0; light < numLights; light ++)
		{
			gl_Position = projection * view * gl_in[vertex].gl_Position;
			EmitVertex();
			gl_Position = projection * view * position[light];
			EmitVertex();

			EndPrimitive();
		}
	}
	
}
