#version 450 core

in vec4 worldPosFrag;
in vec3 lightPos;
in float farPlane;

in vec2 geoTexCoords;

uniform sampler2D texture_alpha1;
uniform bool hasAlphaTexture;

void main()
{
	
	if (hasAlphaTexture) {
		// As our models don't contain semitransparent elements, it is okay to just discard the whole fragment.
		vec4 alphaValue = texture(texture_alpha1, geoTexCoords);
		if (alphaValue.r < 0.1)
			discard;
	}

    float lightDistance = length(worldPosFrag.xyz - lightPos);
    
    // map to [0;1] range by dividing by far_plane, the depth is now linear
    lightDistance = lightDistance / farPlane;
    
    gl_FragDepth = lightDistance;
}  