#version 450 core

layout (triangles) in;
layout (triangle_strip, max_vertices=18) out;

in vec3 worldPosFrag1[];
in vec3 worldNormal1[];
in vec2 texCoords1[];

out vec3 worldPosFrag;
out vec3 worldNormal;
out vec2 texCoords;

uniform mat4 lightSpaceMatrices[6];

void main()
{
    for(int face = 0; face < 6; ++face)
    {

        for(int i = 0; i < 3; ++i) // for each triangle vertex
        {
            gl_Layer = face; // built-in variable that specifies to which face we render.
            worldPosFrag = worldPosFrag1[i];
            worldNormal = worldNormal1[i];
            texCoords = texCoords1[i];
            gl_Position = lightSpaceMatrices[face] * gl_in[i].gl_Position;
            EmitVertex();
        }    
        EndPrimitive();
    }
} 