#version 450 core

layout (location = 0) in vec3 position;
layout (location = 1) in vec3 normal;
layout (location = 2) in vec2 texcoords;
layout (location = 3) in vec3 tangent;
layout (location = 4) in vec3 bitangent;

layout(std140, binding = 0) uniform VP
{
    mat4 view;
    mat4 projection;
    vec4 waterClipPlane;
};

uniform mat4 model;
uniform mat3 normalMat;

out VertexData
{
	vec3 positionOS;
	vec2 texCoords;
	vec3 normalOS;
	vec3 tangentOS;
	vec3 bitangentOS;
} vertex;


void main()
{
    gl_Position = model * vec4(position, 1.0f);
    gl_ClipDistance[0] =  dot(vec4(vec3(model * vec4(position, 1.0f)),1), waterClipPlane);

	vertex.positionOS	= position;
	vertex.texCoords	= texcoords;
	vertex.normalOS		= normal;
	vertex.tangentOS	= tangent;
	vertex.bitangentOS	= bitangent;
}