#version 450 core 

out vec4 FragColor;

in vec2 texCoords;

uniform sampler2D quadTexture;
uniform float exposure;
uniform float gamma;

void main()
{ 
	vec3 colorHDR =  texture(quadTexture, texCoords).xyz;

    // Reinhard tone mapping
    float luminance = dot(colorHDR, vec3(0.2126, 0.7152, 0.0722));
    float mappedLuminance = luminance / (luminance + 1.0);
    vec3 colorLDR = colorHDR * (mappedLuminance / luminance);
    colorLDR *= exposure;

    // gamma correction
    colorLDR = pow(colorLDR, vec3(1.0 / gamma));

    FragColor = vec4(colorLDR,1.0f);
}