#version 450 core

in vec3 worldPosFrag;
in vec3 worldNormal;

uniform vec3 cameraPos;
uniform samplerCube skybox;

out vec4 FragColor;

void main() {

	vec3 fragNormal = normalize(worldNormal);
	vec3 fragToEye = normalize(cameraPos - worldPosFrag);
	vec3 reflection = reflect(fragToEye, fragNormal);

	vec3 result = texture(skybox, -reflection).xyz;

	FragColor = vec4(result,1.0f);
}