#version 450 core

//If you declare a uniform that isn't used anywhere in your GLSL code the compiler will silently
//remove the variable from the compiled version which is the cause for several frustrating errors; keep this in mind!

layout (location = 0) in vec3 position;

layout(std140, binding = 0) uniform VP{
    mat4 view;
    mat4 projection;
};

out vec3 cubemapDir;


void main()
{
    gl_Position = projection * mat4(mat3(view)) * vec4(position, 1.0f);
    cubemapDir = position;

}