#version 450 core
layout (triangles) in;
layout (line_strip, max_vertices = 18) out;

layout(std140, binding = 0) uniform VP
{
    mat4 view;
    mat4 projection;
    vec4 waterClipPlane;
};

in VS_OUT{
    vec3 N;
    vec3 T;
    vec3 B;
} gs_in[];

const float MAGNITUDE = 0.002;


void GenerateLine(int index)
{
    //N
    gl_Position = projection * view * gl_in[index].gl_Position;
    EmitVertex();
    gl_Position = projection * view * (gl_in[index].gl_Position + vec4(gs_in[index].N, 0.0) * MAGNITUDE * 3);
    EmitVertex();
    //T
    gl_Position = projection * view * gl_in[index].gl_Position;
    EmitVertex();
    gl_Position = projection * view * (gl_in[index].gl_Position + vec4(gs_in[index].T, 0.0) * MAGNITUDE * 2);
    EmitVertex();
    //B
    gl_Position = projection * view * gl_in[index].gl_Position;
    EmitVertex();
    gl_Position = projection * view * (gl_in[index].gl_Position + vec4(gs_in[index].B, 0.0) * MAGNITUDE);
    EmitVertex();

    EndPrimitive();
}

void main()
{
    GenerateLine(0); // first vertex normal
    GenerateLine(1); // second vertex normal
    GenerateLine(2); // third vertex normal
}