#version 450 core
layout (location = 0) in vec3 position;
layout (location = 1) in vec3 normal;
layout (location = 3) in vec3 tangent;
layout (location = 4) in vec3 bitangent;

uniform mat4 model;
uniform mat3 normalMat;


out VS_OUT{
    vec3 N;
    vec3 T;
    vec3 B;
} vs_out;


void main()
{
    vs_out.N = normalize(normalMat * normal);
    vs_out.T = normalize(normalMat * tangent);
    vs_out.B = normalize(normalMat * bitangent);
    gl_Position = model * vec4(position, 1.0); 
}